﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Com.Rscja.Deviceapi;
using System.Diagnostics;
using Android.Graphics;


namespace xm_Fingerpint
{
	[Activity (Label = "get")]			
	public class get : Activity
	{
		EditText ID;
		EditText Name;
		EditText df;
		ImageView img;
		Button btn;

		CheckBox chb;
		TextView labmsg;
		ProgressDialog progressDialog;
		System.Threading.Thread  thread;
		protected override void OnCreate (Bundle bundle)
		{
			base.OnCreate (bundle);
			SetContentView (Resource.Layout.Get);
			// Create your application here

			InitView ();
		}

		void InitView()
		{
			ID = FindViewById<EditText> (Resource.Id.geteditid);
			Name = FindViewById<EditText> (Resource.Id.geteditname);
			df = FindViewById<EditText> (Resource.Id.geteditfs);
			img = FindViewById<ImageView> (Resource.Id.getImg);
			btn = FindViewById<Button> (Resource.Id.getbtn);
			chb = FindViewById<CheckBox> (Resource.Id.checkBox2);
			labmsg = FindViewById<TextView> (Resource.Id.getlabmsg);
			btn.Click += new EventHandler (delegate {
				get2();
			});

		}

		void get2()
		{
			ID.Text = "";
			Name.Text = "";
			df.Text = "0";labmsg.Text = "";
			bool isshow = false;
			isshow = chb.Checked;



			progressDialog = ProgressDialog.Show(this,
				"", "Doing", true, false);
			progressDialog.SetCancelable(true);

			new System.Threading.Thread(() =>
				{
					this.RunOnUiThread(() =>
						{
							run(isshow);
							progressDialog.Dismiss();
						});
				}).Start();
		}

		void run(bool isshow)
		{ int searchPageID = -1;
			int searchScore = -1;
			String searchName = "";
			if (!PubClass.fp.Image) {
				labmsg.Text = GetString (Resource.String.getimageFail);
				return;
			}

			if (PubClass.fp.GenChar (Com.Rscja.Deviceapi.Fingerprint.BufferEnum.B1)) {
				int[] result = null;
				int exeCount = 0;
				do {
					exeCount++;
					result = PubClass.fp.Search (Fingerprint.BufferEnum.B1, 0, 1000);					

				} while (result == null && exeCount < 3);

				if (result != null) {
					searchPageID = result [0];
					searchScore = result [1];
					ID.Text = searchPageID.ToString ();
					string[] list=	PubClass.GetFile ();
					string[] tmplist;
					foreach (string li in list) {
						tmplist = (li.Substring (0, li.Length - 4)).Split('_');
						　　
						if (tmplist [0] == searchPageID.ToString ()) {
							Name.Text = tmplist [1];
							break;
						}
					}
					df.Text = searchScore.ToString ();
					if (isshow) {
						// 显示指纹图片
						if (PubClass.fp.Image) {
							if (PubClass.fp.UpImage (1,
								    Android.OS.Environment.ExternalStorageDirectory.ToString () + "/finger.bmp") != -1) {
								Bitmap bitmap = BitmapFactory.DecodeFile (
									                Android.OS.Environment.ExternalStorageDirectory.ToString () + "/finger.bmp");
								img.SetImageBitmap (bitmap);
								return;

							} else {
								labmsg.Text = GetString (Resource.String.getimageup);
								return;
							}
						} else {
							labmsg.Text = GetString (Resource.String.getimageup);
							return;
						}
					} else
						return;

				} else {
					labmsg.Text = GetString (Resource.String.getsearchfail);
					return;
				}

			} else {
				labmsg.Text = GetString (Resource.String.getimage1);
				return;
			}


		}


	}

}


